Subject: Re: Per-queue stats question

From: Jakub Kicinski <[email-masked]>
Date: Fri, 16 Aug 2024 08:44:52 -0700

On Fri, 16 Aug 2024 10:19:48 +0100 Joe Damato wrote:
> On Thu, Aug 15, 2024 at 12:42:47PM -0700, Jakub Kicinski wrote:
> > > On a related note, I notice that the stat_cmp() function within that
> > >  selftest returns the first nonzero delta it finds in the stats, so
> > >  that if (say) tx-packets goes forwards but rx-packets goes backwards,
> > >  it will return >0 causing the rx-packets delta to be ignored.  Is
> > >  this intended behaviour, or should I submit a patch?  
> > 
> > Looks like a bug.  
> 
> FWIW, while debugging the stats stuff on mlx5, I tweaked the
> stat_cmp function to output a lot more information about each of the
> values to help me debug.
> 
> It seemed too verbose for an upstream patch at the time, but since
> you are going through the same process a patch might make a lot of
> sense.

We are in a desperate need of a better debugging flow :(
I hope Mohsin's patch to add verbose printing is ready soon,
it should be _a_ start.